# encoding: UTF-8
module Admin
  class ProductsController < Admin::ApplicationController
    before_filter :set_relation_options, only: [:new, :edit, :create, :update]
    # GET /products
    # GET /products.json
    def index
      @products = Product.all

      respond_to do |format|
        format.html # index.html.erb
        format.json { render json: @products }
      end
    end

    # GET /products/1
    # GET /products/1.json
    def show
      @product = Product.find(params[:id])

      respond_to do |format|
        format.html # show.html.erb
        format.json { render json: @product }
      end
    end

    # GET /products/new
    # GET /products/new.json
    def new
      @product = Product.new

      respond_to do |format|
        format.html # new.html.erb
        format.json { render json: @product }
      end
    end

    # GET /products/1/edit
    def edit
      @product = Product.find(params[:id])
    end

    # POST /products
    # POST /products.json
    def create
      @product = Product.new(product_params)
      @product.supplier_id = params[:product][:supplier_id]

      respond_to do |format|
        if @product.save
          format.html { redirect_to [:admin, @product], notice: t('action.create.successfull', model: Product.model_name.human) }
          format.json { render json: @product, status: :created, location: @product }
        else
          format.html { render action: "new" }
          format.json { render json: @product.errors, status: :unprocessable_entity }
        end
      end
    end

    # PUT /products/1
    # PUT /products/1.json
    def update
      @product = Product.find(params[:id])

      respond_to do |format|
        if @product.update_attributes(product_params)
          format.html { redirect_to [:admin, @product], notice: t('action.update.successfull', model: Product.model_name.human) }
          format.json { head :no_content }
        else
          format.html { render action: "edit" }
          format.json { render json: @product.errors, status: :unprocessable_entity }
        end
      end
    end

    # DELETE /products/1
    # DELETE /products/1.json
    def destroy
      @product = Product.find(params[:id])
      @product.destroy

      respond_to do |format|
        format.html { redirect_to admin_products_path, notice: t('action.destroy.successfull', model: Product.model_name.human) }
        format.json { head :no_content }
      end
    end

    private

    def set_relation_options
      @suppliers = Supplier.all
      @product_categories = ProductCategory.all
    end

    def product_params
      params.require(:product).permit!
    end
  end
end
